<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * comuser_uploader - плагин для MaxSite CMS 
 * загрузка файлов комюзерами и вставка в комментарий
**/


# функция автоподключения плагина
function comuser_uploader_autoload($args = array())
{	
    mso_hook_add( 'main_menu_add_comuser', 'comuser_uploader_menu'); // добавление в меню ссылки на загрузки
	mso_hook_add( 'admin_init', 'comuser_uploader_admin_init');
	mso_hook_add( 'head', 'comuser_uploader_head');
	mso_hook_add('custom_page_404', 'comuser_uploader_custom_page_404');
	
	mso_hook_add( 'forum_comments_content_end', 'comuser_uploader_forum'); // для вставки формы загрузки по хуку редактора форума 
	
	mso_hook_add( 'comments_content_end', 'comuser_uploader_comments'); // для формы загрузки изображений в комментарий
	mso_hook_add( 'comments_content', 'comuser_uploader_content'); // хук на вывод контента после обработки всех тэгов
	mso_hook_add( 'comment_button_more', 'comuser_uploader_button'); // хук на вывод кнопки в bb-коды
    mso_register_widget('use_uploads_widget', t('Используемые загрузки')	);

}

# функция выполняется при активации (вкл) плагина
function comuser_uploader_activate($args = array()){
	mso_create_allow('comuser_uploader',  t('Админ-доступ к настройкам', 'admin'));
	require(getinfo('plugins_dir') . 'comuser_uploader/install.php');
	comuser_uploader_add_options();
	return $args;
}

// добавляем пункт в меню пользователя
function comuser_uploader_menu($menu='') 
{
  $options_template = mso_get_option('comuser_uploads_options_template', 'plugins', array());

  if (isset($options_template['uploads_slug'])) $uploads_slug = $options_template['uploads_slug'];
  else $uploads_slug = 'uploads';
  
  if (isset($options_template['profile_slug'])) $profile_slug = $options_template['profile_slug'];
  else $profile_slug = 'profile';

  if (isset($options_template['uploads_title'])) $uploads_title = $options_template['uploads_title'];
  else $uploads_title = 'Загрузки';  
  
  $uploads_title = 'Загрузки';
  return $menu . NR .  $profile_slug . '/' . $uploads_slug . ' | ' . $uploads_title . '|||i-download';
}


// вывод формы загрузки изображений пользователями после комментария
function comuser_uploader_comments($args = array()) 
{
  if ($comuser = is_login_comuser())
  {
	$comusers_id = $comuser['comusers_id'];  
	require(getinfo('plugins_dir') . 'comuser_uploader/manager-comments.php');
  }	  
  return $args;
}


// вывод формы загрузки изображений пользователями в форуме
function comuser_uploader_forum($args = array()) 
{
  if ($comuser = is_login_comuser())
  {
	$comusers_id = $comuser['comusers_id'];  
    echo '<link rel="stylesheet" href="' . getinfo('plugins_url') . 'comuser_uploader/style_comments.css">';	
	// mso_load_script(getinfo('plugins_url') . 'comuser_uploader/filedrag.js');
	echo '<script src="' . getinfo('plugins_url') . 'comuser_uploader/filedrag.js' . '"></script>';
	require(getinfo('plugins_dir') . 'comuser_uploader/manager-comments.php');
  }	  
  return $args;
}


function comuser_uploader_head($args = array()) 
{
  if ( ($comuser = is_login_comuser()) and (is_type('page') ))
  {	
    echo '<link rel="stylesheet" href="' . getinfo('plugins_url') . 'comuser_uploader/style_comments.css">';  	
    mso_load_script(getinfo('plugins_url') . 'comment_smiles/comment_smiles.js');	
	// mso_load_script(getinfo('plugins_url') . 'comuser_uploader/filedrag.js');
	echo '<script src="' . getinfo('plugins_url') . 'comuser_uploader/filedrag.js' . '"></script>';
  }	
  return $args;
}

function comuser_uploader_content($text = '') 
{
	$options = mso_get_option('comuser_uploader', 'plugins', array() );	
    $subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile';
    $style  = (isset($options['google_pdf_style'])) ? $options['google_pdf_style'] : 'width: 600px; height: 200px;';	
    $frame  = (isset($options['frame'])) ? $options['frame'] : 1;	
	
	$url = getinfo('uploads_url') . $subdir . '/';
	$doc_url = getinfo('admin_url') . 'plugins/admin_files/document_plain.png';

		
	$preg = array(
		'~\[myimg=(.[^ ]*?)\](.*?)\[\/myimg\]~si' => '<a href="' . $url . '$1/$2" class="lightbox"><img title="$2" src="' . $url . '$1/mini/$2" alt="$2"></a>',
		'~\[myfile=(.[^ ]*?)\](.*?)\[\/myfile\]~si' => '<a target="_blank" href="' . $url . '$1/$2"><img title="$2" src="' . $doc_url . '" alt="$2"></a>',
	);

	if ($frame) $preg['~\[mydoc=(.[^ ]*?)\](.*?)\[\/mydoc\]~si'] = '<iframe src="https://docs.google.com/viewer?url=' . $url . '$1/$2&embedded=true" style="' . $options['google_pdf_style'] . '" frameborder="0">Ваш браузер не поддерживает фреймы</iframe>';
    else $preg['~\[mydoc=(.[^ ]*?)\](.*?)\[\/mydoc\]~si'] = '<a target="_blank" href="' . $url . '$1/$2"><img title="$2" src="' . $doc_url . '" alt="$2"></a>';

   return preg_replace(array_keys($preg), array_values($preg), $text);
}

function comuser_uploader_admin_init($args = array()) 
{	
	if ( !mso_check_allow('comuser_uploader') ) 
	{
		return $args;
	}
	$this_plugin_url = 'comuser_uploader'; // url и hook
	mso_admin_menu_add('plugins', $this_plugin_url, '' . t('Загрузки комюзеров', 'admin') . '');
	mso_admin_url_hook ($this_plugin_url, 'comuser_uploader_admin');
	return $args;
}

// добавляем кнопку в bb-коды
function comuser_uploader_button() 
{	
	  if ($comuser = is_login_comuser()) return '<button type="text" id="all-files-upload" class="comment_button_i all-files-upload button i-upload" title="' . t('Файл') . '">' . t('Файлы') . '</button>';
}

// администрирование загрузок комюзерами
function comuser_uploader_admin($args = array()) 
{
	if ( !mso_check_allow('comuser_uploader') ) 
	{
		echo 'Доступ запрещен';
		return $args;
	}
	mso_hook_add_dinamic( 'mso_admin_header', ' return $args . "' . t('Загрузки комюзеров - управление', 'admin') . '"; ' );
	mso_hook_add_dinamic( 'admin_title', ' return "' . t('Загрузки комюзеров', 'admin') . ' - " . $args; ' );
	require(getinfo('plugins_dir') . 'comuser_uploader/admin/index.php');
}

function comuser_uploader_custom_page_404($args = false)
{
  // вывод приватной страницы профиля пользователя (личного кабинета)

  //отследим ссылки вида siteurl/profile/uploads   siteurl/profiles/1/uploads
  
  $segment1 = mso_segment(1);
  $segment2 = mso_segment(2);
  $segment3 = mso_segment(3);  
  $error = 'no_found';
  
  // получаем информацию о приватных страниц, заданную в плагине comusers_uploads
  $options_template = mso_get_option('comuser_uploader_options_template', 'plugins', array());

  if (!isset($options_template['uploads_slug'])) $options_template['uploads_slug'] = 'uploads';
  if (!isset($options_template['profile_slug'])) $options_template['profile_slug'] = 'profile';
  if (!isset($options_template['profiles_slug'])) $options_template['profiles_slug'] = 'profiles';
  
  // если ссылка вида siteurl/profile/uploads - страница личного кабинета
  if (($segment1 == $options_template['profile_slug']) and ($segment2 == $options_template['uploads_slug']))
  {	  
	  require(getinfo('plugins_dir') . 'comuser_uploader/uploads.php');
  }
  
  // если ссылка вида siteurl/profiles/1/uploads
  elseif (($segment1 == $options_template['profiles_slug']) and ($segment3 == $options_template['uploads_slug']))
  {
	  if (is_numeric($segment2))
	  {	 
        require_once( getinfo('common_dir') . 'comments.php' );  
        $comuser = mso_get_comuser($segment2);
        if (!isset($comuser[0])) 
	    {
	       require( getinfo('plugins_dir') . 'comuser_uploader/out_of_comuser.php' ); // подключили страницу отсутствия пользователя
	       return true; 
	    }	 
        else require(getinfo('plugins_dir') . 'comuser_uploader/uploads_all.php');  
	  }
	  else $error='comusers_error';
  }

  // обработака $error ?? пока не раелизована - просто 404
  if (!$error) return true;
  else return $args;
}


function comuser_uploader_uninstall($args = array())
{
	// удалим созданные опции и разрешения
	mso_delete_option_mask('comuser_uploader', 'plugins'); 
	mso_remove_allow('comuser_uploader'); 
	mso_delete_option_mask('comuser_uploader_widget', 'plugins' );	
	mso_delete_option_mask('use_uploads_widget', 'plugins' );	
	mso_delete_option_mask('comuser_uploader_options_template', 'plugins'); 
	return $args;
}


require(getinfo('plugins_dir') . 'comuser_uploader/widget.php'); 


?>